#include <config.h>

#include "antilink.h"
#include "safeio.h"
#ifdef WITH_DMALLOC
# include <dmalloc.h>
#endif

static int subst(char *line, size_t line_len,
                 const char * const pat_str,
                 const char * const pat_subst)
{
    const size_t pat_str_len = strlen(pat_str);
    const size_t pat_subst_len = strlen(pat_subst);
    char *z;
    
    while ((z = strstr(line, pat_str)) != NULL) {
        if (pat_str_len > pat_subst_len) {
            memcpy(z, pat_subst, pat_subst_len);
            memmove(z + pat_subst_len, z + pat_str_len, 
                    strlen(z + pat_str_len) + 1U);
            line = z + pat_subst_len;            
        } else {
            if (pat_str_len != pat_subst_len) {
                const size_t s = strlen(z) + 1U;
                
                if ((size_t) (z - line) + pat_subst_len + s >= line_len) {
                    return -1;
                }
                memmove(z + pat_subst_len - pat_str_len, z, s);
            }
            memcpy(z, pat_subst, pat_subst_len);
            line = z + pat_subst_len;
        }
    }    
    return 0;
}

int main(int argc, char *argv[])
{
    const char *pat_str;
    const char *pat_subst;
    char line[ANTILINK_SUBST_LINE_MAX];

    if (argc != 3 || (pat_str = argv[1]) == NULL || *pat_str == 0 ||
        (pat_subst = argv[2]) == NULL) {
        return 1;
    }
    (void) close(2);
    while (fgets(line, sizeof line, stdin) != NULL) {
        if (subst(line, sizeof line, pat_str, pat_subst) != 0) {
            return 2;
        }
        puts(line);
        fflush(stdout);
    }    
    return 0;
}
